#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
sysread(STDIN,$data,$ENV{CONTENT_LENGTH});
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$data{$field}=$value;
	}
}

# Validation fields
if (!$data{Name})
{
	push (@errors,"You must fill <b>Name</b> field<br>\n");
	$flag=1;
}
if (!$data{Title})
{
	push (@errors,"You must fill <b>Title</b> field<br>\n");
	$flag=1;
}
if (!$data{URL})
{
	push (@errors,"You must fill <b>Site URL</b> field<br>\n");
	$flag=1;
}
unless ($data{URL}=~/^http:\/\//)
{
	push (@errors,"Field <b>Site URL</b> must start with http://<br>\n");
	$flag=1;
}
if (!$data{Email})
{
	push (@errors,"You must fill <b>E-mail</b> field<br>\n");
	$flag=1;
}
unless ($data{Email}=~/.+\@.+/)
{
	push (@errors,"Field <b>E-mail</b> has incorrect value<br>\n");
	$flag=1;
}
if (!$data{Username})
{
	push (@errors,"You must fill <b>Choose username</b> field<br>\n");
	$flag=1;
}
if ($data{Username}=~/\W+/)
{
	push (@errors,"<b>Username</b> must consists of letters and digits<br>\n");
	$flag=1;
}
if (!$data{Password})
{
	push (@errors,"You must fill <b>Choose password</b> field<br>\n");
	$flag=1;
}
if ($data{Password}=~/\W+/)
{
	push (@errors,"<b>Password</b> must consists of letters and digits<br>\n");
	$flag=1;
}
unless ($data{Wrname})
{
	push (@errors,"<b>WebRing</b> is not choosen<br>\n");
	$flag=1;
}
&error(@errors) if ($flag);
$sth=$dbh->query("LOCK TABLES rw_rings READ, rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM rw_users WHERE username='$data{Username}'");
$uid=$sth->fetchrow;
$sth=$dbh->query("SELECT rname,status,email,name,hcode FROM rw_rings,rw_users WHERE (rid=$data{Wrname} AND rw_rings.uid=rw_users.uid)");
($rname,$status,$email,$name,$htmlcode)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($uid)
{
	push (@errors,"Account with such <b>Username</b> is already exist<br>\n");
	$flag=1;
}
if (!$status)
{
	push (@errors,"WebRing is not approved yet<br>\n");
	$flag=1;
}
if ($status==2)
{
	push (@errors,"WebRing is temporary disabled<br>\n");
	$flag=1;
}
&error(@errors) if ($flag);

# Register user
$data{Name}=~s/'/\\'/g;
$data{Title}=~s/'/\\'/g;
$data{Desc}=~s/'/\\'/g;
$data{Desc}=~s/\r\n/<br>/g;
$sth=$dbh->query("LOCK TABLES rw_users WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO rw_users (email,username,password,name,acctype,status) VALUES ('$data{Email}','$data{Username}','$data{Password}','$data{Name}',2,0)");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($uid)
{
	push (@errors,"Unknown SQL error. Can register account.<br>\n");
	&error(@errors);
}
$sth=$dbh->query("LOCK TABLES rw_sites WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO rw_sites (rid,uid,sname,surl,hits,sdescr) VALUES ($data{Wrname},$uid,'$data{Title}','$data{URL}',0,'$data{Desc}')");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($sid)
{
	push (@errors,"Unknown SQL error. Can register website.<br>\n");
	&error(@errors);
}
$user=$uid;
$webring=$data{Wrname};
$rid=$data{Wrname};
$fullrn=$rname;
$htmlcode=~s/\~/\\\~/g;
eval "\$htmlcode=qq~$htmlcode~;";

# Print success
$successmsg=qq~Your site is registered succesfully in $rname WebRing<br>Now you must include the HTML code in all referring pages on the site you registered:<form><center><textarea cols=48 rows=10>&lt;!--Begin $title code--&gt;\n$htmlcode\n&lt;!--End $title code--&gt;</textarea></center>Please wait until your account will be activated (dont forget to place HTML code on your website)~;

# Send email
open (MAIL,"|$mailprog");
print MAIL "To: $email ($name)\n";
print MAIL "From: $rwemail ($title)\n";
print MAIL "Subject: New site was added to your WebRing. Authorization needed\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT site_reg_to_leader,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
open (MAIL,"|$mailprog");
print MAIL "To: $data{Email} ($data{Name})\n";
print MAIL "From: $email ($name)\n";
print MAIL "Subject: Registration information\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT site_reg_to_user,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
&closedb;
open(F,"<$rwpath/template/success.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;


sub error
{
@errors=@_;
&closedb;
open(F,"<$rwpath/template/error.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
